/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;
using static SeriousSIP.SIPBridge;

namespace SeriousSIP.Model
{
    /// <summary>
    /// leg - Record ALeg, BLeg or Any.    fileName - The file name to be played back.    clearDigitsBuffer - If true, the digits buffer is cleared before the playback.    stopOnDigit - Tf true, the playback is interrupted by any key pressed.    waitForCompletion - If true, the http request will reply only when the playback will be completed, otherwise a webhook shall be used to be notified on completion.
    /// </summary>
    [DataContract]
    public partial class BridgeInfoParams :  IEquatable<BridgeInfoParams>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BridgeInfoParams" /> class.
        /// <summary>
        /// id - The unique ID of the bridge.&#xD;&#xA;
        /// aLegCallId - The unique ID of the A sip leg.&#xD;&#xA;
        /// bLegCallId - The unique ID of the B sip leg.&#xD;&#xA;
        /// relayDtmf - True if the bridge relays DTMF as well.&#xD;&#xA;
        /// action - The current action being executed on the call (Idle, Playing, Recording).&#xD;&#xA;
        /// </summary>
        public BridgeInfoParams(string id, string aLegCallId = default(string), string bLegCallId = default(string), bool? relayDtmf = default(bool?), SIPBridgeAction action = SIPBridgeAction.Idle)
        {
            this.Id = id;
            this.ALegCallId = aLegCallId;
            this.BLegCallId = bLegCallId;
            this.RelayDtmf = relayDtmf;
            this.Action = action;
        }

        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name = "id", EmitDefaultValue = false)]
        public string Id { get; set; }

        /// <summary>
        /// Gets or Sets ALegCallId
        /// </summary>
        [DataMember(Name="aLegCallId", EmitDefaultValue=false)]
        public string ALegCallId { get; set; }

        /// <summary>
        /// Gets or Sets BLegCallId
        /// </summary>
        [DataMember(Name="bLegCallId", EmitDefaultValue=false)]
        public string BLegCallId { get; set; }

        /// <summary>
        /// Gets or Sets RelayDtmf
        /// </summary>
        [DataMember(Name= "relayDtmf", EmitDefaultValue=false)]
        public bool? RelayDtmf { get; set; }

        /// <summary>
        /// Gets or Sets Action
        /// </summary>
        [DataMember(Name="action", EmitDefaultValue=false)]
        public SIPBridgeAction Action { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class BridgeInfoParams {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  ALegCallId: ").Append(ALegCallId).Append("\n");
            sb.Append("  BLegCallId: ").Append(BLegCallId).Append("\n");
            sb.Append("  RelayDtmf: ").Append(RelayDtmf).Append("\n");
            sb.Append("  Action: ").Append(Action).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as BridgePlayParams);
        }

        /// <summary>
        /// Returns true if BridgePlayParams instances are equal
        /// </summary>
        /// <param name="input">Instance of BridgePlayParams to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(BridgeInfoParams input)
        {
            if (input == null)
                return false;

            return
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && (
                    this.ALegCallId == input.ALegCallId ||
                    (this.ALegCallId != null &&
                    this.ALegCallId.Equals(input.ALegCallId))
                ) &&
                (
                    this.BLegCallId == input.BLegCallId ||
                    (this.BLegCallId != null &&
                    this.BLegCallId.Equals(input.BLegCallId))
                ) &&
                (
                    this.RelayDtmf == input.RelayDtmf ||
                    (this.RelayDtmf != null &&
                    this.RelayDtmf.Equals(input.RelayDtmf))
                ) && 
                (
                    this.Action == input.Action ||
                    (this.Action.Equals(input.Action))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.ALegCallId != null)
                    hashCode = hashCode * 59 + this.ALegCallId.GetHashCode();
                if (this.BLegCallId != null)
                    hashCode = hashCode * 59 + this.BLegCallId.GetHashCode();
                if (this.RelayDtmf != null)
                    hashCode = hashCode * 59 + this.RelayDtmf.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
